#!/usr/bin/env python

import sys
import os
import time
import re
import operator
try:
	import pygtk
	pygtk.require("2.0")
except:
	pass
try:
	import gtk
	import gtk.glade
except:
	sys.exit(1)

class TipCalc:
	
	def __init__(self):
		if os.path.isfile("/usr/local/lib/tipcalculator.glade") :
			self.gladefile = "/usr/local/lib/tipcalculator.glade"  
		elif os.path.isfile("./tipcalculator.glade") :
			self.gladefile = "./tipcalculator.glade"  

		self.wTree = gtk.glade.XML(self.gladefile)
		self.window = self.wTree.get_widget("window1")
		if (self.window):
			self.window.connect("destroy", gtk.main_quit)
		
		self.bill = self.wTree.get_widget("spin_bill")
		self.tip = self.wTree.get_widget("spin_tip")
		self.tipdue = self.wTree.get_widget("entry_tip_dollar")
		self.total = self.wTree.get_widget("entry_total")
		self.split = self.wTree.get_widget("spin_split")
		self.persondue = self.wTree.get_widget("entry_per_person")
		self.tax = self.wTree.get_widget("spin_tax")
		self.tax_percent = self.wTree.get_widget("rad_tax_percent")
		self.tax_price = self.wTree.get_widget("rad_tax_price")
		
		#self.bill.set_property('hildon-input-mode', (1 << 0 | 1 << 1 | 1 << 2))
		self.bill.set_property('hildon-input-mode', (1 << 1 | 1 << 2))
		self.tip.set_property('hildon-input-mode', self.bill.get_property('hildon-input-mode'))
		self.tax.set_property('hildon-input-mode', self.bill.get_property('hildon-input-mode'))
		self.split.set_property('hildon-input-mode', 1 << 1)
		
		self.about_dialog = None  #-- Not sure if I need these two
		self.error_dialog = None  #-- lines...

		dic = {
			# Process signal from button
			"calculatetip" : self.calculate_tip,
			"updatesplit" : self.update_split}
		self.wTree.signal_autoconnect(dic)
	
	
	def ErrPopUp(self,msg):
		error_dialog = gtk.MessageDialog(None,0,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE,msg)
		def close(dialog, response, editor):
			editor.about_dialog = None
			dialog.destroy()
		error_dialog.connect("response", close, self)
		# error_dialog.connect("delete-event", delete_event, self)
		self.error_dialog = error_dialog
		error_dialog.run()
	
		
	def calculate_tip(self, widget):
		tip = round(float(self.bill.get_value())*(float(self.tip.get_value())/100.00),2)
		self.tipdue.set_text(str("%.2f" % tip))
		if(self.tax_percent.get_active()) :
			tax = round(float(self.bill.get_value())*(float(self.tax.get_value())/100.00),2)
		else :
			tax = round(float(self.tax.get_value()), 2)
		self.total.set_text(str("%.2f" % round(float(tip) + float(self.bill.get_text()) + float(tax),2)))
		if(self.split.get_text() == "1") :
			self.persondue.set_text(self.total.get_text())
		else :
			self.persondue.set_text(str("%.2f" % round(float(self.total.get_text())/float(self.split.get_text()) ,2)))
	
	def update_split(self,widget):
		if(self.split.get_text() == "1") :
			self.persondue.set_text(self.total.get_text())
		else :
			self.persondue.set_text(str("%.2f" % round(float(self.total.get_text())/float(self.split.get_text()) ,2)))

	
if __name__ == "__main__":
	title = 'Tip Calculator'
	handle = TipCalc()
	gtk.main()
	sys.exit(1)
